' Program Name: ISAPPEND.BAS
'
'$INCLUDE: 'QBX.BI'

DEFINT A-Z

DECLARE FUNCTION AppendPath$ ()
DECLARE FUNCTION AppendVersion$ ()
DECLARE FUNCTION IsAppendLoaded% ()
DECLARE SUB FExist (FileName$, OutPut$)


CLS

CONST False = 0, TRUE = NOT False
DIM SHARED InReg AS RegTypeX, OutReg AS RegTypeX

ON ERROR GOTO Wrong

IF IsAppendLoaded THEN
  PRINT "APPEND Version "; AppendVersion$; " is Loaded"
  IF ASC(AppendPath$) <> 59 THEN
    Append$ = AppendPath$
    PRINT "APPEND = "; Append$
  END IF
  PRINT "The Current Directory is: "; CURDIR$
ELSE
  PRINT "APPEND is not Loaded"
END IF

IF COMMAND$ <> "" AND IsAppendLoaded THEN
  FileName$ = COMMAND$
  FileName$ = LTRIM$(FileName$)
  OPEN FileName$ FOR INPUT AS FREEFILE
  CLOSE
  IF flag THEN
    PRINT "File not Accessible"
  ELSE
    PRINT "File "; FileName$; " is Accessible"
    IF DIR$(FileName$) = "" THEN
      PRINT "File "; FileName$; " is in an Appended Directory"
    END IF
    CALL FExist(FileName$, OutPut$)
    PRINT OutPut$
  END IF
END IF
END

Wrong:
  IF ERR = 53 THEN flag = TRUE
  RESUME NEXT


FUNCTION AppendPath$

InReg.ax = &HB704
CALL InterruptX(&H2F, InReg, OutReg)
DEF SEG = OutReg.es
DO
  a$ = CHR$(PEEK(OutReg.di + i))
  IF a$ = CHR$(0) THEN EXIT DO
  b$ = b$ + a$
  i = i + 1
LOOP

AppendPath$ = b$
DEF SEG
END FUNCTION


FUNCTION AppendVersion$

InReg.ax = &HB710
CALL InterruptX(&H2F, InReg, OutReg)
Major$ = LTRIM$(STR$(OutReg.dx AND 255))
Minor$ = LTRIM$(STR$(OutReg.dx \ 256))
AppendVersion$ = Major$ + "." + Minor$

END FUNCTION


SUB FExist (FileName$, OutPut$)

Path$ = UCASE$(AppendPath$)

DO WHILE LEN(Path$) > 0
  Found = False
  ' discard any leading semicolons
  DO WHILE LEFT$(Path$, 1) = ";"
    Path$ = RIGHT$(Path$, LEN(Path$) - 1)
  LOOP

  NextSemi = INSTR(Path$, ";")
  ' extract the next directory path from the list
  APath$ = LEFT$(Path$, ABS(NextSemi > 0) * (NextSemi - 1))
  ' The above statement "fails" for last path in the string
  ' (APath$ will be null, and Path contains last path - so swap)
  IF APath$ = "" AND LEN(Path$) > 0 THEN
   SWAP APath$, Path$
  END IF
  Hold$ = LEFT$(CURDIR$, 2)
  IF APath$ = Hold$ + "\" THEN APath$ = Hold$
  
  ' "pop" the "current" path from the front of the path list
  Path$ = RIGHT$(Path$, ABS(NextSemi > 0) * ((LEN(Path$) - LEN(APath$)) - 1))
  TruePath$ = DIR$(APath$ + "\" + FileName$)
  IF TruePath$ = FileName$ THEN
    OutPut$ = "File's true pathname: " + APath$ + "\" + FileName$
    TruePath$ = ""
  END IF
LOOP
END SUB


FUNCTION IsAppendLoaded

InReg.ax = &HB700
CALL InterruptX(&H2F, InReg, OutReg)

IF (OutReg.ax AND 255) = 0 THEN
  IsAppendLoaded = False
ELSE
  IsAppendLoaded = TRUE
END IF

END FUNCTION
