' Ticket.Bas - Program to demonstrate the Linkin' Logs
'              linked list manipulation package.
'
' This program reads a file that contains a series of records,
' each of which contains the name of a driver and their average
' motoring speed. It builds a linked list from this data, then
' prints a list of those drivers that are speeders.
'
' $INCLUDE: 'LNKNTYPS.BI' <- must include this/you may modify it
' $INCLUDE: 'LNKNLOGS.BI' <- must include this/you may NOT modify it

DECLARE SUB PrintList (ListHandle AS INTEGER)
DECLARE SUB BuildDriverList (ListHandle AS INTEGER)
DECLARE SUB KeepOnlySpeeders (ListHandle AS INTEGER)
DECLARE SUB DumpListNodes ()

CLS
BuildDriverList DriverList%
IF DriverList% <> nil THEN
  PRINT "All traffic information:"
  PrintList DriverList%
  KeepOnlySpeeders DriverList%
  PRINT : PRINT "All lawbreakers found:"
  PrintList DriverList%
END IF
END


DATA 60, Tony, 65, Kim, 0, Justin, 100, Scottie, 25, Tim, 80, Marco
DATA 87, Jeff, 45, Spock, 55, Kirk, 50, Sulu, 0,""

SUB BuildDriverList (DriveListHdl AS INTEGER)
DIM aPtr AS INTEGER
DIM DriverRecord AS NodeDataType
NewList DriveListHdl
IF DriveListHdl <> nil THEN
  DO
    READ Speed%, Driver$
    IF LEN(Driver$) > 0 THEN
      NewNode aPtr
      IF aPtr <> nil THEN
        DriverRecord.fRec.fDataRec = Driver$
        DriverRecord.fKey.fValue = Speed%
        StoreNodeData aPtr, DriverRecord
        InsertInPlace DriveListHdl, aPtr
      END IF
    END IF
  LOOP UNTIL LEN(Driver$) = 0
ELSE
  PRINT "Couldn't allocate the driver list!"
END IF
END SUB

SUB KeepOnlySpeeders (aListHdl AS INTEGER)
DIM aPtr AS INTEGER
DIM nodeData AS NodeDataType
Traverse aListHdl, aPtr, FINDFIRST
saveFirst% = aPtr
prev = aPtr
DO WHILE NextNode(aPtr) <> nil
  prev = aPtr
  Traverse aListHdl, aPtr, FINDNEXT
  GetNodeData aPtr, nodeData
  IF nodeData.fKey.fValue <= 55 THEN
    aPtr = prev
    DeleteAfter aPtr
  END IF
LOOP
GetNodeData saveFirst%, nodeData
IF nodeData.fKey.fValue <= 55 THEN
  PopNode aListHdl
END IF
END SUB

SUB PrintList (ListHandle AS INTEGER)
DIM aPtr AS INTEGER
DIM NodeData AS NodeDataType

Traverse ListHandle, aPtr, FINDFIRST
DO WHILE aPtr <> nil
  GetNodeData aPtr, NodeData
  PRINT "Name: "; LTRIM$(RTRIM$(NodeData.fRec.fDataRec));
  PRINT " speed: "; NodeData.fKey.fValue
  Traverse ListHandle, aPtr, FINDNEXT
LOOP
END SUB
